//----------------------------------------------------------------------------
// Rot3D.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Rot3D.pas
//----------------------------------------------------------------------------
#ifndef Rot3DHPP
#define Rot3DHPP
//----------------------------------------------------------------------------
#include <DsgnIntf.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Rot3d
{
//-- type declarations -------------------------------------------------------
enum TColorScheme { csBWG, csSystem };

enum TFrameStyle { fsNone, fsSimple, fsLowered, fsRaised, fsEmbossed, fsEngraved };

enum ItemType { tkNone, tkMarkAt, tkLineto, tkLine, tkMoveto, tkEverything };

enum TBoundingBox { bbNone, bbFrame, bbFaces };

struct TDrawCan;
typedef TDrawCan *PDrawCan;

struct TDrawCan
{
	TDrawCan *Next;
	double x;
	double y;
	double z;
	Graphics::TColor color;
	ItemType Element;
	union
	{
		Byte mark;
		struct 
		{
			double x2;
			double y2;
			double z2;
			
		};
		
	};
} ;

enum MouseActMode { maNone, maRotate, maZoom, maRotAndZoom, maPan };

class __declspec(delphiclass) TRot3D;
class __declspec(pascalimplementation) TRot3D : public Controls::TGraphicControl
{
	typedef Controls::TGraphicControl inherited;
	
private:
	long CubeCorners[8][3];
	double FViewAngle[3];
	Graphics::TBitmap* GrafBmp;
	MouseActMode FMouseAction;
	TDrawCan *RcFrstCan;
	TDrawCan *RcLastCan;
	Graphics::TColor RcDataCol;
	Graphics::TColor RcFrameCol;
	Graphics::TColor RcChartCol;
	Graphics::TColor FColBlackLine;
	Graphics::TColor FColGrayLine;
	Graphics::TColor FColWhiteLine;
	TColorScheme FColorScheme;
	Graphics::TColor FColorCubeFrame;
	Graphics::TColor FColorCubeHidLin;
	Graphics::TColor FColorCubeFaceHi;
	Graphics::TColor FColorCubeFaceLo;
	TBoundingBox FBoundBox;
	int FBBSize;
	int FAxSize;
	bool FShowAxes;
	TFrameStyle FFrameStyle;
	int FMagnify;
	double MagAnchor;
	int FMinCoord[3];
	int FMaxCoord[3];
	Graphics::TColor FItemColors[32];
	int FCentX;
	int FCentY;
	int FCentXAnchor;
	int FCentYAnchor;
	long RotMat[3][3];
	int NRotObj;
	void *FRotDataX;
	void *FRotDataY;
	void *FRotDataZ;
	void *FRotProp;
	void *FRotMark;
	Graphics::TFontStyles FTextFontStyle;
	Byte FTextMarkSize;
	int MouseAnchorX;
	int MouseAnchorY;
	void __fastcall ConstructDataBmp(bool BlkWhite);
	void __fastcall InitGraf(void);
	void __fastcall ConstructFrame(void);
	void __fastcall SetDataCol(Graphics::TColor c);
	void __fastcall SetFrameCol(Graphics::TColor c);
	void __fastcall SetChartCol(Graphics::TColor c);
	void __fastcall SetColCubeFrame(Graphics::TColor c);
	void __fastcall SetColCubeHidLin(Graphics::TColor c);
	void __fastcall SetColCubeFaceLow(Graphics::TColor c);
	void __fastcall SetColCubeFaceHigh(Graphics::TColor c);
	void __fastcall SetMagnify(double mag);
	double __fastcall GetMagnify(void);
	PDrawCan __fastcall GetFirstItemLL(void);
	ItemType __fastcall GetTypeOfFirstItem(void);
	ItemType __fastcall GetTypeOfLastItem(void);
	void __fastcall SetColorScheme(TColorScheme Value);
	void __fastcall SetCubeCorners(void);
	void __fastcall SetFrameStyle(TFrameStyle value);
	void __fastcall SetBoundBoxStyle(TBoundingBox value);
	void __fastcall SetBoundBoxSize(int value);
	int __fastcall GetBoundBoxSize(void);
	void __fastcall SetAxSize(int value);
	void __fastcall SetCentX(int value);
	void __fastcall SetCentY(int value);
	void __fastcall SetShowAxes(bool value);
	void __fastcall SetTextFontStyle(Graphics::TFontStyles tfs);
	void __fastcall SetTextMarkSize(Byte tms);
	void __fastcall SetViewAngleX(double value);
	void __fastcall SetViewAngleY(double value);
	void __fastcall SetViewAngleZ(double value);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall CalcRotMatrix(void);
	
public:
	__fastcall virtual TRot3D(Classes::TComponent* AOwner);
	__fastcall virtual ~TRot3D(void);
	void __fastcall Clear(void);
	__property Graphics::TColor ColorData = {read=RcDataCol, write=SetDataCol, default=0};
	void __fastcall CopyToBMP( System::AnsiString FName);
	void __fastcall CopyToClipboard(void);
	void __fastcall MakeVisible(void);
	void __fastcall Drawto(double x, double y, double z);
	PDrawCan __fastcall FindNearestItemReal(double mx, double my, double mz, ItemType ItemID, double &dist
		);
	TDrawCan __fastcall GetItemParams(PDrawCan Item);
	void __fastcall SetItemParams(PDrawCan Item, const TDrawCan &ItParams);
	void __fastcall Line(double x1, double y1, double z1, double x2, double y2, double z2);
	void __fastcall Moveto(double x, double y, double z);
	void __fastcall MarkAt(double x, double y, double z, Byte mk);
	void __fastcall RemoveLastItem(void);
	void __fastcall RemoveFirstItem(void);
	void __fastcall SetViewAngles(double vax, double vay, double vaz);
	__property PDrawCan FirstItemOfLinkedList = {read=GetFirstItemLL, nodefault};
	PDrawCan __fastcall FindNearestItemScreen(double mx, double my, double mz, ItemType ItemID, double 
		&dist);
	__property ItemType TypeOfLastItem = {read=GetTypeOfLastItem, nodefault};
	__property ItemType TypeOfFirstItem = {read=GetTypeOfFirstItem, nodefault};
	
__published:
	__property Font ;
	__property Align ;
	__property Visible ;
	__property ShowHint ;
	__property PopupMenu ;
	__property int CentX = {read=FCentX, write=SetCentX, nodefault};
	__property int CentY = {read=FCentY, write=SetCentY, nodefault};
	__property Graphics::TColor ColorFrame = {read=RcFrameCol, write=SetFrameCol, default=0};
	__property Graphics::TColor ColorChart = {read=RcChartCol, write=SetChartCol, default=16777215};
	__property TColorScheme ColorScheme = {read=FColorScheme, write=SetColorScheme, nodefault};
	__property Graphics::TColor ColorCubeFrame = {read=FColorCubeFrame, write=SetColCubeFrame, nodefault
		};
	__property Graphics::TColor ColorCubeHidLin = {read=FColorCubeHidLin, write=SetColCubeHidLin, nodefault
		};
	__property Graphics::TColor ColorCubeFaceLow = {read=FColorCubeFaceLo, write=SetColCubeFaceLow, nodefault
		};
	__property Graphics::TColor ColorCubeFaceHigh = {read=FColorCubeFaceHi, write=SetColCubeFaceHigh, nodefault
		};
	__property TFrameStyle FrameStyle = {read=FFrameStyle, write=SetFrameStyle, nodefault};
	__property double Magnification = {read=GetMagnify, write=SetMagnify};
	__property MouseActMode MouseAction = {read=FMouseAction, write=FMouseAction, nodefault};
	__property TBoundingBox BoundBoxStyle = {read=FBoundBox, write=SetBoundBoxStyle, nodefault};
	__property int BoundBoxSize = {read=GetBoundBoxSize, write=SetBoundBoxSize, nodefault};
	__property int AxSize = {read=FAxSize, write=SetAxSize, nodefault};
	__property bool ShowAxes = {read=FShowAxes, write=SetShowAxes, nodefault};
	__property Graphics::TFontStyles TextFontStyle = {read=FTextFontStyle, write=SetTextFontStyle, nodefault
		};
	__property Byte TextMarkSize = {read=FTextMarkSize, write=SetTextMarkSize, nodefault};
	__property double ViewAngleX = {read=FViewAngle[34], write=SetViewAngleX};
	__property double ViewAngleY = {read=FViewAngle[35], write=SetViewAngleY};
	__property double ViewAngleZ = {read=FViewAngle[36], write=SetViewAngleZ};
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
};

//-- var, const, procedure ---------------------------------------------------
#define defDataCol (int)(0)
#define defFrameCol (int)(0)
#define defChartCol (int)(16777215)
#define defHeight (Word)(300)
#define defWidth (Word)(450)
#define MaxItemColors (Byte)(31)
#define MaxR3Marks (Byte)(25)
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class Graphics::TFontStyles ;

}	/* namespace Rot3d */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rot3d;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Rot3D
